
;CodeVisionAVR C Compiler V1.25.5 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8535
;Program type           : Application
;Clock frequency        : 14,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Polygon.vec"
	.INCLUDE "Polygon.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.1 Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : "Polygon" transceiver
;       9 Version :
;      10 Date    : 13.08.2006
;      11 Author  : Freeware, for evaluation and non-commercial use only
;      12 Company :
;      13 Comments:      FIR     .  PLL.
;      14               32.
;      15 
;      16 
;      17 Chip type           : ATmega8535
;      18 Program type        : Application
;      19 Clock frequency     : 14,000000 MHz
;      20 Memory model        : Small
;      21 External SRAM size  : 0
;      22 Data Stack size     : 128
;      23 *****************************************************/
;      24 
;      25 #include <mega8535.h>
;      26 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      27 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      28 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      29 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      30 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      31 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      32 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      33 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      34 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      35 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      36 	#endif
	#endif
;      37 unsigned int i;
;      38 #define FIRST_ADC_INPUT 0        //    
;      39 #define LAST_ADC_INPUT 0         //     (     0- )
;      40 unsigned int flt_x[31] @0x60;    //   (   ,    060)
	.ORG 0x60
_flt_x:
	.BYTE 0x3E
	.ORG 0xE0
;      41 unsigned int flt_B[31] @0x9E;    //   
	.ORG 0x9E
_flt_B:
	.BYTE 0x3E
	.ORG 0xE0
;      42 unsigned int flt_y[31] @0xE0;    //    
_flt_y:
	.BYTE 0x3E
;      43 unsigned int flt_B1[31] @0x11E;  //   
_flt_B1:
	.BYTE 0x3E
;      44 unsigned int flt_z @0x160;       //     
	.ORG 0x160
_flt_z:
	.BYTE 0x2
	.ORG 0x15C
;      45 unsigned int flt_gain @0x162;    //  
	.ORG 0x162
_flt_gain:
	.BYTE 0x2
	.ORG 0x15C
;      46 unsigned int sig_peak;           //     
;      47 unsigned int trx=0;              //        :  0- ,  =0-  .
;      48 unsigned int cw_beep=0;          //     (0-   >0- )
;      49 unsigned int cw_pause=0;         //    (>0-   )
;      50 unsigned int ddot=250;           //  
_ddot:
	.BYTE 0x2
;      51 unsigned int dash=750;           //  
_dash:
	.BYTE 0x2
;      52 
;      53 unsigned int trx_pause=0;     //   
_trx_pause:
	.BYTE 0x2
;      54 int fgen=512;                    //   (     )
_fgen:
	.BYTE 0x2
;      55 unsigned int frx=512;  //880       //  
_frx:
	.BYTE 0x2
;      56 int dfrx=1;                      //       (0...1023)
_dfrx:
	.BYTE 0x2
;      57 #define ADC_VREF_TYPE 0xC0       //      
;      58 
;      59 
;      60 //     2 (Timer 2 output compare interrupt service routine)
;      61 // 2   32           -
;      62 //    
;      63 interrupt [TIM2_COMP] void timer2_comp_isr(void)
;      64 {

	.CSEG
_timer2_comp_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      65 
;      66 if (trx==0){ ADCSRA|=0x40;};  //  ,    
	MOV  R0,R8
	OR   R0,R9
	BRNE _0x8
	SBI  0x6,6
_0x8:
;      67 if (trx_pause==0){
	RCALL SUBOPT_0x0
	SBIW R30,0
	BRNE _0x9
;      68 //   ,         trx   :
;      69 if (trx>0)
	RCALL SUBOPT_0x1
	BRSH _0xA
;      70         {trx--;
	MOVW R30,R8
	SBIW R30,1
	MOVW R8,R30
;      71         if (cw_beep>0) {cw_beep--; if (OCR1A>0) {OCR1A=0;} else {OCR1A=1023;};};
	RCALL SUBOPT_0x2
	BRSH _0xB
	MOVW R30,R10
	SBIW R30,1
	MOVW R10,R30
	IN   R30,0x2A
	IN   R31,0x2A+1
	MOVW R26,R30
	RCALL __CPW02
	BRSH _0xC
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x42
_0xC:
	LDI  R30,LOW(1023)
	LDI  R31,HIGH(1023)
_0x42:
	OUT  0x2A+1,R31
	OUT  0x2A,R30
_0xB:
;      72         if (cw_pause>0 && cw_beep==0) {cw_pause--;};
	RCALL SUBOPT_0x3
	BRSH _0xF
	RCALL SUBOPT_0x2
	BREQ _0x10
_0xF:
	RJMP _0xE
_0x10:
	MOVW R30,R12
	SBIW R30,1
	MOVW R12,R30
_0xE:
;      73         };
_0xA:
;      74                   } else { trx_pause--;};
	RJMP _0x11
_0x9:
	RCALL SUBOPT_0x0
	SBIW R30,1
	RCALL SUBOPT_0x4
_0x11:
;      75 
;      76 
;      77 
;      78 if (dfrx>50){
	LDS  R26,_dfrx
	LDS  R27,_dfrx+1
	SBIW R26,51
	BRLT _0x12
;      79 if ((PINC & 0x02)==0 && frx>192){frx--;};     //     (  1) -   ,      
	SBIC 0x13,1
	RJMP _0x14
	RCALL SUBOPT_0x5
	CPI  R26,LOW(0xC1)
	LDI  R30,HIGH(0xC1)
	CPC  R27,R30
	BRSH _0x15
_0x14:
	RJMP _0x13
_0x15:
	RCALL SUBOPT_0x6
	SBIW R30,1
	RCALL SUBOPT_0x7
_0x13:
;      80 if ((PINC & 0x04)==0 && frx<1022){frx++;};  //  (  2)-   
	SBIC 0x13,2
	RJMP _0x17
	RCALL SUBOPT_0x5
	CPI  R26,LOW(0x3FE)
	LDI  R30,HIGH(0x3FE)
	CPC  R27,R30
	BRLO _0x18
_0x17:
	RJMP _0x16
_0x18:
	RCALL SUBOPT_0x6
	ADIW R30,1
	RCALL SUBOPT_0x7
_0x16:
;      81 dfrx=0;} else {dfrx++;};
	LDI  R30,0
	STS  _dfrx,R30
	STS  _dfrx+1,R30
	RJMP _0x19
_0x12:
	LDS  R30,_dfrx
	LDS  R31,_dfrx+1
	ADIW R30,1
	STS  _dfrx,R30
	STS  _dfrx+1,R31
_0x19:
;      82 if (trx>0) {OCR1B=frx-192;} else {OCR1B=frx;};//      -     500  (1024*500/8000=64)
	RCALL SUBOPT_0x1
	BRSH _0x1A
	RCALL SUBOPT_0x6
	SUBI R30,LOW(192)
	SBCI R31,HIGH(192)
	RJMP _0x43
_0x1A:
	RCALL SUBOPT_0x6
_0x43:
	OUT  0x28+1,R31
	OUT  0x28,R30
;      83 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;      84 
;      85 
;      86 //      (ADC interrupt service routine)        
;      87 //     ,       0
;      88 interrupt [ADC_INT] void adc_isr(void)
;      89 {
_adc_isr:
	ST   -Y,R30
	ST   -Y,R31
;      90 //register static unsigned char input_index=0;
;      91 
;      92 ADMUX=(FIRST_ADC_INPUT|ADC_VREF_TYPE);  //+input_index;  //      0
	LDI  R30,LOW(192)
	OUT  0x7,R30
;      93 
;      94 
;      95 //           
;      96 //  .    FIR-
;      97 //------------------------------------------------------------------------------------
;      98 
;      99 #asm
;     100 push R0
push R0
;     101 push R1
push R1
;     102 push R2
push R2
;     103 push R16
push R16
;     104 push R17
push R17
;     105 push R18
push R18
;     106 push R19
push R19
;     107 push R20
push R20
;     108 push R21
push R21
;     109 push R22
push R22
;     110 push R23
push R23
;     111 push R24
push R24
;     112 push R25
push R25
;     113 push R26
push R26
;     114 push R27
push R27
;     115 push R28        ; 
push R28        ;  
;     116 push R29        ;
push R29        ;
;     117 push R30        ;     
push R30        ;     
;     118 	clr     R2
	clr     R2
;     119 	clr	R22			;Clear avg Low byte
	clr	R22			;Clear avg Low byte
;     120 	clr	R23
	clr	R23
;     121 	clr	R24			;Clear avg Low byte
	clr	R24			;Clear avg Low byte
;     122 	clr	R25
	clr	R25
;     123 	clr	R26			;Clear avg Low byte
	clr	R26			;Clear avg Low byte
;     124 	clr	R27
	clr	R27
;     125 	clr	R28			;Clear avg Low byte
	clr	R28			;Clear avg Low byte
;     126 	clr	R29
	clr	R29
;     127 	clr     R30
	clr     R30
;     128 mav8_3:
mav8_3:	
;     129         ldi     R28, $60        ;      
        ldi     R28, $60        ;      
;     130  c11:
 c11:	
;     131         ldd	R22,Y+2
        ldd	R22,Y+2		
;     132 	ldd	R23,Y+3
	ldd	R23,Y+3		
;     133         std     Y+0, R22
        std     Y+0, R22
;     134         std     Y+1, R23
        std     Y+1, R23        
;     135         ldd	R20,Y+62        ;32
        ldd	R20,Y+62        ;32		
;     136   	ldd	R21,Y+63        ;33
  	ldd	R21,Y+63        ;33		        
;     137         clr     R2
        clr     R2
;     138         mul     R22, R20
        mul     R22, R20
;     139         movw    R17:R16, R1:R0
        movw    R17:R16, R1:R0
;     140         mul     R23, R20        ;mulsu
        mul     R23, R20        ;mulsu
;     141 ;        sbc     R19, R2
;        sbc     R19, R2
;     142         add     R17, R0
        add     R17, R0
;     143         adc     R18, R1
        adc     R18, R1
;     144         adc     R19, R2
        adc     R19, R2
;     145         add     R24,R16
        add     R24,R16
;     146         adc     R25,R17
        adc     R25,R17
;     147         adc     R26,R18
        adc     R26,R18
;     148         adc     R27,R19
        adc     R27,R19
;     149         adiw    R29:R28,$02
        adiw    R29:R28,$02
;     150         inc     R30
        inc     R30
;     151         cpi     R30,$1F         ;7E
        cpi     R30,$1F         ;7E
;     152         brlo    c11
        brlo    c11
;     153         IN      R22,0x4
        IN      R22,0x4
;     154  	IN      R23,0x4+1
 	IN      R23,0x4+1
;     155         cpi     R23, $03             ;     3,   ,      11
        cpi     R23, $03             ;     3,   ,      11
;     156         brlo    no_ovfl2
        brlo    no_ovfl2
;     157         cpi     R22, $F0             ;       F0,   ,      11
        cpi     R22, $F0             ;       F0,   ,      11
;     158         brlo    no_ovfl2
        brlo    no_ovfl2
;     159         ldi     R23, $03             ;   ,     03F0
        ldi     R23, $03             ;   ,     03F0
;     160         ldi     R22, $F0
        ldi     R22, $F0    
;     161 no_ovfl2:
no_ovfl2:
;     162         sts     $9C, R22        ;$7E, R22
        sts     $9C, R22        ;$7E, R22
;     163         sts     $9D, R23        ;$7F, R23
        sts     $9D, R23        ;$7F, R23      
;     164         clr     R28
        clr     R28
;     165 div_cl2:
div_cl2:
;     166 	lsr	R27			;       2
	lsr	R27			;       2
;     167 	ror	R26			;
	ror	R26			;
;     168 	ror	R25			;
	ror	R25			;
;     169 	ror	R24			;
	ror	R24			;
;     170         inc     R28
        inc     R28
;     171         cpi     R28,$08                 ;            ;cpi R28,$08
        cpi     R28,$08                 ;            ;cpi R28,$08
;     172         brlt    div_cl2
        brlt    div_cl2
;     173         sts     $11C, R24        ;$7E, R22 ;        
        sts     $11C, R24        ;$7E, R22 ;        
;     174         sts     $11D, R25        ;$7F, R23 ;
        sts     $11D, R25        ;$7F, R23 ;     
;     175         clr     R2
        clr     R2
;     176         clr     R30
        clr     R30                   
;     177         clr     R29
        clr     R29
;     178         ldi     R28, $E0       ;      
        ldi     R28, $E0       ;      
;     179  c13:
 c13:	
;     180         ldd	R22,Y+2
        ldd	R22,Y+2		
;     181 	ldd	R23,Y+3
	ldd	R23,Y+3		
;     182         std     Y+0, R22
        std     Y+0, R22
;     183         std     Y+1, R23
        std     Y+1, R23        
;     184         ldd	R20,Y+62        ;32
        ldd	R20,Y+62        ;32		
;     185   	ldd	R21,Y+63        ;33
  	ldd	R21,Y+63        ;33		        
;     186         clr     R2
        clr     R2
;     187         mul     R22, R20
        mul     R22, R20
;     188         movw    R17:R16, R1:R0
        movw    R17:R16, R1:R0
;     189         mul     R23, R20         ;mulsu
        mul     R23, R20         ;mulsu
;     190 ;        sbc     R19, R2
;        sbc     R19, R2
;     191         add     R17, R0
        add     R17, R0
;     192         adc     R18, R1
        adc     R18, R1
;     193         adc     R19, R2
        adc     R19, R2
;     194         add     R24,R16
        add     R24,R16
;     195         adc     R25,R17
        adc     R25,R17
;     196         adc     R26,R18
        adc     R26,R18
;     197         adc     R27,R19
        adc     R27,R19
;     198         adiw    R29:R28,$02
        adiw    R29:R28,$02
;     199         inc     R30
        inc     R30
;     200         cpi     R30,$1F         ;7E
        cpi     R30,$1F         ;7E
;     201         brlo    c13
        brlo    c13
;     202         clr     R28
        clr     R28
;     203 div_cl4:
div_cl4:
;     204 	lsr	R27			;divide by 2
	lsr	R27			;divide by 2
;     205 	ror	R26			;
	ror	R26			;
;     206 	ror	R25			;
	ror	R25			;
;     207 	ror	R24			;
	ror	R24			;
;     208         inc     R28
        inc     R28
;     209         cpi     R28,$08
        cpi     R28,$08
;     210         brlt    div_cl4
        brlt    div_cl4
;     211 ;        cpi     R25, $04
;        cpi     R25, $04
;     212 ;        brlo    no_ovfl1
;        brlo    no_ovfl1
;     213 ;        ldi     R25, $03
;        ldi     R25, $03
;     214 ;        ldi     R24, $FE
;        ldi     R24, $FE
;     215 no_ovfl1:
no_ovfl1:
;     216 	sts     $160, R24               ;$E0, R24        ;$A0, R24
	sts     $160, R24               ;$E0, R24        ;$A0, R24
;     217         sts     $161, R25               ;$E1, R25        ;$A1, R25
        sts     $161, R25               ;$E1, R25        ;$A1, R25
;     218 pop R30
pop R30
;     219 pop R29
pop R29
;     220 pop R28
pop R28
;     221 pop R27
pop R27
;     222 pop R26
pop R26
;     223 pop R25
pop R25
;     224 pop R24
pop R24
;     225 pop R23
pop R23
;     226 pop R22
pop R22
;     227 pop R21
pop R21
;     228 pop R20
pop R20
;     229 pop R19
pop R19
;     230 pop R18
pop R18
;     231 pop R17
pop R17
;     232 pop R16
pop R16
;     233 pop R2
pop R2
;     234 pop R1
pop R1
;     235 pop R0
pop R0
;     236 #endasm
;     237 
;     238 OCR1A=flt_z;  //  -        
	LDS  R30,_flt_z
	LDS  R31,_flt_z+1
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     239 
;     240 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     241 
;     242 //   .      (/)
;     243 //  / 
;     244 void main(void)
;     245 {
_main:
;     246 
;     247 //   /
;     248 //   
;     249 //     ,  
;     250 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     251 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     252 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     253 DDRA=0x00;
	OUT  0x1A,R30
;     254 
;     255 //   B
;     256 //    3   ,  
;     257 //  3 - 
;     258 // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In
;     259 // State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T
;     260 PORTB=0x00;
	OUT  0x18,R30
;     261 DDRB=0x08;
	LDI  R30,LOW(8)
	OUT  0x17,R30
;     262 
;     263 //   
;     264 //  7,6,3,2,1,0 - , 5,4 - 
;     265 // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
;     266 // State7=T State6=T State5=0 State4=0 State3=P State2=P State1=P State0=P
;     267 PORTC=0xFF; //0C
	LDI  R30,LOW(255)
	OUT  0x15,R30
;     268 DDRC=0x18; //3C
	LDI  R30,LOW(24)
	OUT  0x14,R30
;     269 
;     270 //   D
;     271 //  5,4 -  ( ),  - 
;     272 // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
;     273 // State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T
;     274 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     275 DDRD=0x30;
	LDI  R30,LOW(48)
	OUT  0x11,R30
;     276 
;     277 //   0
;     278 //  :  
;     279 //  : 14000,000 kHz
;     280 // : Normal top=FFh
;     281 // OC0 :      
;     282 TCCR0=0x19;
	LDI  R30,LOW(25)
	OUT  0x33,R30
;     283 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     284 OCR0=0x01;     // 14000/(2*(1+OCR))=3,500 MHz   //14000/64(presc)/55(0x37)=3.9773 kHz    1.9886
	LDI  R30,LOW(1)
	OUT  0x3C,R30
;     285 
;     286 //   1
;     287 //  :  
;     288 //  : 14000,000 kHz
;     289 // : Fast PWM top=03FFh ( )
;     290 // OC1A : Non-Inv.
;     291 // OC1B : Inverted
;     292 //   : On
;     293 //    
;     294 //    1 
;     295 //   : Off
;     296 //      : Off
;     297 //      : Off
;     298 TCCR1A=0xF3;
	LDI  R30,LOW(243)
	OUT  0x2F,R30
;     299 TCCR1B=0x89;
	LDI  R30,LOW(137)
	OUT  0x2E,R30
;     300 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     301 TCNT1L=0x00;
	OUT  0x2C,R30
;     302 ICR1H=0x00;
	OUT  0x27,R30
;     303 ICR1L=0x00;
	OUT  0x26,R30
;     304 OCR1AH=0x00;
	OUT  0x2B,R30
;     305 OCR1AL=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2A,R30
;     306 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     307 OCR1BL=0xFF;            //14000/1(presc)/1024(fast PWM top=03FFh)=13.672 kHz
	LDI  R30,LOW(255)
	OUT  0x28,R30
;     308 
;     309 
;     310 //   2
;     311 // : 32 
;     312 // : Normal top=FFh
;     313 // OC2 output: Disconnected
;     314 ASSR=0x08;      //08;      // Clock source: External Clock  //0x00 -   !!!!!
	LDI  R30,LOW(8)
	OUT  0x22,R30
;     315 TCCR2=0x09;     //CTC, no prescaling              //0C;     //04(/64) //CTC no Normal mode, OC2 off, presc=64
	LDI  R30,LOW(9)
	OUT  0x25,R30
;     316 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     317 OCR2=0x06;      //32000/6=5,33kHz Compare Match on 06,    32   6.      
	LDI  R30,LOW(6)
	OUT  0x23,R30
;     318 
;     319 //    ( )
;     320 // INT0: Off
;     321 // INT1: Off
;     322 // INT2: Off
;     323 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;     324 MCUCSR=0x00;
	OUT  0x34,R30
;     325 
;     326 //    /
;     327 TIMSK=0x80; //  T0  -  ,   2 -   32 
	LDI  R30,LOW(128)
	OUT  0x39,R30
;     328 
;     329 //  
;     330 // Analog Comparator: Off ()
;     331 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     332 ACSR=0x80;
	OUT  0x8,R30
;     333 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     334 
;     335 //  
;     336 //   : ,    AREF
;     337 //    ,   
;     338 ADMUX=FIRST_ADC_INPUT|ADC_VREF_TYPE;
	LDI  R30,LOW(192)
	OUT  0x7,R30
;     339 ADCSRA=0xDA; //    ,      2
	LDI  R30,LOW(218)
	OUT  0x6,R30
;     340 SFIOR&=0x0F; //
	IN   R30,0x30
	ANDI R30,LOW(0xF)
	OUT  0x30,R30
;     341 SFIOR|=0x70; //
	IN   R30,0x30
	ORI  R30,LOW(0x70)
	OUT  0x30,R30
;     342 
;     343 //        FIR-.
;     344 //    /  
;     345 // 700/950 Hz;
;     346 flt_B[0]=12;
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	STS  _flt_B,R30
	STS  _flt_B+1,R31
;     347 flt_B[1]= 13;
	__POINTW1MN _flt_B,2
	RCALL SUBOPT_0x8
;     348 flt_B[2]=16;
	__POINTW1MN _flt_B,4
	RCALL SUBOPT_0x9
;     349 flt_B[3]=18;
	__POINTW1MN _flt_B,6
	RCALL SUBOPT_0xA
;     350 flt_B[4]= 16;
	__POINTW1MN _flt_B,8
	RCALL SUBOPT_0x9
;     351 flt_B[5]=10;
	__POINTW1MN _flt_B,10
	RCALL SUBOPT_0xB
;     352 flt_B[6]=6;
	__POINTW1MN _flt_B,12
	RCALL SUBOPT_0xC
;     353 flt_B[7]=10;
	__POINTW1MN _flt_B,14
	RCALL SUBOPT_0xB
;     354 flt_B[8]= 19;
	__POINTW1MN _flt_B,16
	RCALL SUBOPT_0xD
;     355 flt_B[9]=24;
	__POINTW1MN _flt_B,18
	RCALL SUBOPT_0xE
;     356 flt_B[10]=19;
	__POINTW1MN _flt_B,20
	RCALL SUBOPT_0xD
;     357 flt_B[11]= 7;
	__POINTW1MN _flt_B,22
	RCALL SUBOPT_0xF
;     358 flt_B[12]=1;
	__POINTW1MN _flt_B,24
	RCALL SUBOPT_0x10
;     359 flt_B[13]=7;
	__POINTW1MN _flt_B,26
	RCALL SUBOPT_0xF
;     360 flt_B[14]= 20;
	__POINTW1MN _flt_B,28
	RCALL SUBOPT_0x11
;     361 flt_B[15]=27;
	__POINTW1MN _flt_B,30
	RCALL SUBOPT_0x12
;     362 flt_B[16]=20;
	__POINTW1MN _flt_B,32
	RCALL SUBOPT_0x11
;     363 flt_B[17]=7;
	__POINTW1MN _flt_B,34
	RCALL SUBOPT_0xF
;     364 flt_B[18]= 1;
	__POINTW1MN _flt_B,36
	RCALL SUBOPT_0x10
;     365 flt_B[19]=7;
	__POINTW1MN _flt_B,38
	RCALL SUBOPT_0xF
;     366 flt_B[20]=19;
	__POINTW1MN _flt_B,40
	RCALL SUBOPT_0xD
;     367 flt_B[21]= 24;
	__POINTW1MN _flt_B,42
	RCALL SUBOPT_0xE
;     368 flt_B[22]=19;
	__POINTW1MN _flt_B,44
	RCALL SUBOPT_0xD
;     369 flt_B[23]=10;
	__POINTW1MN _flt_B,46
	RCALL SUBOPT_0xB
;     370 flt_B[24]= 6;
	__POINTW1MN _flt_B,48
	RCALL SUBOPT_0xC
;     371 flt_B[25]=10;
	__POINTW1MN _flt_B,50
	RCALL SUBOPT_0xB
;     372 flt_B[26]=16;
	__POINTW1MN _flt_B,52
	RCALL SUBOPT_0x9
;     373 flt_B[27]=18;
	__POINTW1MN _flt_B,54
	RCALL SUBOPT_0xA
;     374 flt_B[28]= 16;
	__POINTW1MN _flt_B,56
	RCALL SUBOPT_0x9
;     375 flt_B[29]=13;
	__POINTW1MN _flt_B,58
	RCALL SUBOPT_0x8
;     376 flt_B[30]=12;
	__POINTW1MN _flt_B,60
	RCALL SUBOPT_0x13
;     377 
;     378 // 700/950 Hz;
;     379 flt_B1[0]=12;
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	STS  _flt_B1,R30
	STS  _flt_B1+1,R31
;     380 flt_B1[1]= 13;
	__POINTW1MN _flt_B1,2
	RCALL SUBOPT_0x8
;     381 flt_B1[2]=16;
	__POINTW1MN _flt_B1,4
	RCALL SUBOPT_0x9
;     382 flt_B1[3]=18;
	__POINTW1MN _flt_B1,6
	RCALL SUBOPT_0xA
;     383 flt_B1[4]= 16;
	__POINTW1MN _flt_B1,8
	RCALL SUBOPT_0x9
;     384 flt_B1[5]=10;
	__POINTW1MN _flt_B1,10
	RCALL SUBOPT_0xB
;     385 flt_B1[6]=6;
	__POINTW1MN _flt_B1,12
	RCALL SUBOPT_0xC
;     386 flt_B1[7]=10;
	__POINTW1MN _flt_B1,14
	RCALL SUBOPT_0xB
;     387 flt_B1[8]= 19;
	__POINTW1MN _flt_B1,16
	RCALL SUBOPT_0xD
;     388 flt_B1[9]=24;
	__POINTW1MN _flt_B1,18
	RCALL SUBOPT_0xE
;     389 flt_B1[10]=19;
	__POINTW1MN _flt_B1,20
	RCALL SUBOPT_0xD
;     390 flt_B1[11]= 7;
	__POINTW1MN _flt_B1,22
	RCALL SUBOPT_0xF
;     391 flt_B1[12]=1;
	__POINTW1MN _flt_B1,24
	RCALL SUBOPT_0x10
;     392 flt_B1[13]=7;
	__POINTW1MN _flt_B1,26
	RCALL SUBOPT_0xF
;     393 flt_B1[14]= 20;
	__POINTW1MN _flt_B1,28
	RCALL SUBOPT_0x11
;     394 flt_B1[15]=27;
	__POINTW1MN _flt_B1,30
	RCALL SUBOPT_0x12
;     395 flt_B1[16]=20;
	__POINTW1MN _flt_B1,32
	RCALL SUBOPT_0x11
;     396 flt_B1[17]=7;
	__POINTW1MN _flt_B1,34
	RCALL SUBOPT_0xF
;     397 flt_B1[18]= 1;
	__POINTW1MN _flt_B1,36
	RCALL SUBOPT_0x10
;     398 flt_B1[19]=7;
	__POINTW1MN _flt_B1,38
	RCALL SUBOPT_0xF
;     399 flt_B1[20]=19;
	__POINTW1MN _flt_B1,40
	RCALL SUBOPT_0xD
;     400 flt_B1[21]= 24;
	__POINTW1MN _flt_B1,42
	RCALL SUBOPT_0xE
;     401 flt_B1[22]=19;
	__POINTW1MN _flt_B1,44
	RCALL SUBOPT_0xD
;     402 flt_B1[23]=10;
	__POINTW1MN _flt_B1,46
	RCALL SUBOPT_0xB
;     403 flt_B1[24]= 6;
	__POINTW1MN _flt_B1,48
	RCALL SUBOPT_0xC
;     404 flt_B1[25]=10;
	__POINTW1MN _flt_B1,50
	RCALL SUBOPT_0xB
;     405 flt_B1[26]=16;
	__POINTW1MN _flt_B1,52
	RCALL SUBOPT_0x9
;     406 flt_B1[27]=18;
	__POINTW1MN _flt_B1,54
	RCALL SUBOPT_0xA
;     407 flt_B1[28]= 16;
	__POINTW1MN _flt_B1,56
	RCALL SUBOPT_0x9
;     408 flt_B1[29]=13;
	__POINTW1MN _flt_B1,58
	RCALL SUBOPT_0x8
;     409 flt_B1[30]=12;
	__POINTW1MN _flt_B1,60
	RCALL SUBOPT_0x13
;     410 
;     411 
;     412 //  
;     413 flt_gain=8;
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	STS  _flt_gain,R30
	STS  _flt_gain+1,R31
;     414 
;     415 //  
;     416 #asm("sei")
	sei
;     417 
;     418 //,    -    3   LED
;     419 PORTC=0xE7;
	RCALL SUBOPT_0x14
;     420 for (i=0;i<10000;i++) {};
_0x1D:
	RCALL SUBOPT_0x15
	BRSH _0x1E
	RCALL SUBOPT_0x16
	RJMP _0x1D
_0x1E:
;     421 PORTC=0xF7;               //  ,
	RCALL SUBOPT_0x17
;     422 for (i=0;i<10000;i++) {};
_0x20:
	RCALL SUBOPT_0x15
	BRSH _0x21
	RCALL SUBOPT_0x16
	RJMP _0x20
_0x21:
;     423 PORTC=0xE7;               //  ...
	RCALL SUBOPT_0x14
;     424 for (i=0;i<10000;i++) {};
_0x23:
	RCALL SUBOPT_0x15
	BRSH _0x24
	RCALL SUBOPT_0x16
	RJMP _0x23
_0x24:
;     425 PORTC=0xF7;
	RCALL SUBOPT_0x17
;     426 for (i=0;i<10000;i++) {};
_0x26:
	RCALL SUBOPT_0x15
	BRSH _0x27
	RCALL SUBOPT_0x16
	RJMP _0x26
_0x27:
;     427 PORTC=0xE7;
	RCALL SUBOPT_0x14
;     428 for (i=0;i<10000;i++) {};
_0x29:
	RCALL SUBOPT_0x15
	BRSH _0x2A
	RCALL SUBOPT_0x16
	RJMP _0x29
_0x2A:
;     429 PORTC=0xF7;
	LDI  R30,LOW(247)
	OUT  0x15,R30
;     430 
;     431 //      
;     432 cw_pause=0;
	CLR  R12
	CLR  R13
;     433 cw_beep=0;//      100,      3  LED   .
	CLR  R10
	CLR  R11
;     434 
;     435 //  -    
;     436 //     ,         
;     437 //  trx    (     )
;     438 
;     439 while (1)
_0x2B:
;     440       {
;     441 //sig_peak=sig_peak-1;
;     442 //if (sig_peak<flt_z) {sig_peak=sig_peak+1;} else {sig_peak=sig_peak-1;};
;     443 //if (sig_peak<700) {PORTC=0x00; if (flt_gain>6){flt_gain=flt_gain-1;}} else {PORTC=0xFF; if (flt_gain<10) {flt_gain=flt_gain+1;}};
;     444 
;     445 
;     446 if ((PIND & 0x01)==0 && cw_pause==0) {if (trx==0){ trx_pause=ddot;}; cw_beep=dash; cw_pause=ddot; trx=ddot+dash+ddot+2*dash;}; //else {next_cw_beep=dash;};
	SBIC 0x10,0
	RJMP _0x2F
	RCALL SUBOPT_0x3
	BREQ _0x30
_0x2F:
	RJMP _0x2E
_0x30:
	MOV  R0,R8
	OR   R0,R9
	BRNE _0x31
	RCALL SUBOPT_0x18
_0x31:
	__GETWRMN 10,11,0,_dash
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
_0x2E:
;     447 if ((PIND & 0x02)==0 && cw_pause==0) {if (trx==0){ trx_pause=ddot;}; cw_beep=ddot; cw_pause=ddot; trx=ddot+ddot+ddot+2*dash;}; //else {next_cw_beep=ddot;}; //&& cw_beep==0 && cw_pause==0
	SBIC 0x10,1
	RJMP _0x33
	RCALL SUBOPT_0x3
	BREQ _0x34
_0x33:
	RJMP _0x32
_0x34:
	MOV  R0,R8
	OR   R0,R9
	BRNE _0x35
	RCALL SUBOPT_0x18
_0x35:
	__GETWRMN 10,11,0,_ddot
	RCALL SUBOPT_0x19
	LDS  R30,_ddot
	LDS  R31,_ddot+1
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
_0x32:
;     448 
;     449 if (cw_beep>0 && trx_pause==0) {PORTC|=0x18; if (DDRB==0x00){DDRB=0x08;}; cw_pause=ddot;} else {PORTC&=0xEF; if (DDRB==0x08 && trx>0){DDRB=0x00;};}; // ,   LED,   -  ( ,  4)
	RCALL SUBOPT_0x2
	BRSH _0x37
	LDS  R26,_trx_pause
	LDS  R27,_trx_pause+1
	RCALL __CPW02
	BREQ _0x38
_0x37:
	RJMP _0x36
_0x38:
	IN   R30,0x15
	ORI  R30,LOW(0x18)
	OUT  0x15,R30
	IN   R30,0x17
	CPI  R30,0
	BRNE _0x39
	LDI  R30,LOW(8)
	OUT  0x17,R30
_0x39:
	RCALL SUBOPT_0x19
	RJMP _0x3A
_0x36:
	CBI  0x15,4
	IN   R30,0x17
	CPI  R30,LOW(0x8)
	BRNE _0x3C
	RCALL SUBOPT_0x1
	BRLO _0x3D
_0x3C:
	RJMP _0x3B
_0x3D:
	LDI  R30,LOW(0)
	OUT  0x17,R30
_0x3B:
_0x3A:
;     450 if (trx>0) {PORTC|=0x08;} else {PORTC&=0xF7; if (DDRB==0x00){DDRB=0x08;};}; //   ,       ( ,  3),     -  
	RCALL SUBOPT_0x1
	BRSH _0x3E
	SBI  0x15,3
	RJMP _0x3F
_0x3E:
	CBI  0x15,3
	IN   R30,0x17
	CPI  R30,0
	BRNE _0x40
	LDI  R30,LOW(8)
	OUT  0x17,R30
_0x40:
_0x3F:
;     451 
;     452       };
	RJMP _0x2B
;     453 }
_0x41:
	RJMP _0x41
;     454 
;     455 


;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDS  R30,_trx_pause
	LDS  R31,_trx_pause+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	CLR  R0
	CP   R0,R8
	CPC  R0,R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	CLR  R0
	CP   R0,R12
	CPC  R0,R13
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	STS  _trx_pause,R30
	STS  _trx_pause+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDS  R26,_frx
	LDS  R27,_frx+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	LDS  R30,_frx
	LDS  R31,_frx+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	STS  _frx,R30
	STS  _frx+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x8:
	LDI  R26,LOW(13)
	LDI  R27,HIGH(13)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x9:
	LDI  R26,LOW(16)
	LDI  R27,HIGH(16)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA:
	LDI  R26,LOW(18)
	LDI  R27,HIGH(18)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xB:
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(19)
	LDI  R27,HIGH(19)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xF:
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(20)
	LDI  R27,HIGH(20)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R26,LOW(27)
	LDI  R27,HIGH(27)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(231)
	OUT  0x15,R30
	CLR  R4
	CLR  R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	CP   R4,R30
	CPC  R5,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x16:
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(247)
	OUT  0x15,R30
	CLR  R4
	CLR  R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	LDS  R30,_ddot
	LDS  R31,_ddot+1
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x19:
	__GETWRMN 12,13,0,_ddot
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	LDS  R30,_dash
	LDS  R31,_dash+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1B:
	LDS  R26,_ddot
	LDS  R27,_ddot+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	RCALL SUBOPT_0x1B
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x1A
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0x1C
	MOVW R8,R30
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

;END OF CODE MARKER
__END_OF_CODE:
